routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

Use App\Http\Controllers\Admin\UserController as AdminUserController;
Use App\Http\Controllers\Admin\CommentController as AdminCommentController;
Use App\Http\Controllers\Admin\PictureController as AdminPictureController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::middleware('language')->group(function () {

    Auth::routes();
    Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('pictures', \App\Http\Controllers\PictureController::class)->except('edit', 'update');

    Route::resource('users', \App\Http\Controllers\UserController::class)->only('show', 'edit', 'update');

    Route::resource('comments', \App\Http\Controllers\CommentController::class)->except('index', 'create');






Route::prefix('admin')->name('admin.')->middleware(['auth', 'is_admin'])->group(function () {
    Route::resources([
        'users' => AdminUserController::class,
        'comments' => AdminCommentController::class,
        'pictures' => AdminPictureController::class
    ]);
});


Route::post('/admin/{user}/admin', [AdminUserController::class, 'admin'])->name('admin.users.admin');

});
Route::get('language/{local}', [\App\Http\Controllers\LanguageSwitchController::class, 'switcher'])->name('language.switcher')->where('locale', 'en|ru|es|fr|kg');

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Passport\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function pictures()
    {
        return $this->hasMany(Picture::class);
    }

    public function comments()
    {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\UsersTableEditRequest;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;

class UserController extends Controller
{

    /**
     * UserController constructor.
     */
    public function __construct()
    {
        return $this->middleware('is_admin');
    }

    /**
     * @return Application|Factory|View
     */
    public function index()
    {
        $users = User::all();
        return view('admin.users.index', compact('users'));
    }

    /**
     * @param User $user
     * @return Application|Factory|View
     */
    public function show(User $user)
    {
        return view('admin.users.show', compact('user'));
    }

    /**
     * @param User $user
     * @return Application|Factory|View
     */
    public function edit(User $user)
    {
        return view('admin.users.edit', compact('user'));
    }

    /**
     * @param UsersTableEditRequest $request
     * @param User $user
     * @return RedirectResponse
     */
    public function update(UsersTableEditRequest $request, User $user)
    {
        $user->update($request->all());
        return redirect()->route('admin.users.index')->with('success', __('Successfully updated'));
    }

    /**
     * @param User $user
     * @return RedirectResponse
     */
    public function destroy(User $user)
    {
        $this->authorize('forceDelete', $user);
        $user->delete();
        return redirect()->route('admin.users.index')->with('success', __('Successfully deleted'));
    }

    public function admin(User $user)
    {
        $this->authorize('forceDelete', $user);
        $user->is_admin = !$user->is_admin;
        $user->save();
        return redirect()->back()->with('success', __('Successfully updated'));
    }
}

app/Http/Controllers/Api/UserController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Resources\UserResource;
use App\Models\User;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;
use Illuminate\Http\Response;

class UserController extends Controller
{
    /**
     * ArticleController constructor.
     */
    public function __construct()
    {
        return $this->middleware('auth:api');
    }

    /**
     * Display a listing of the resource.
     *
     * @return AnonymousResourceCollection
     */
    public function index()
    {
        $users = User::paginate(2);
        return UserResource::collection($users);
    }


    /**
     * Display the specified resource.
     *
     * @param User $user
     * @return UserResource
     */
    public function show(User $user)
    {
        return new UserResource($user);
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param User $user
     * @return Response
     */
    public function destroy(User $user)
    {
        $this->authorize('forceDelete', $user);
        $user->delete();
        return response([], 204);
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\UsersTableEditRequest;
use App\Models\User;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;

class UserController extends Controller
{

    /**
     * Display the specified resource.
     *
     * @param User $user
     * @return Application|Factory|View
     */
    public function show(User $user)
    {
        return view('client.users.show', compact('user'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param User $user
     * @return Application|Factory|View
     */
    public function edit(User $user)
    {
        $this->authorize('update', $user);
        return view('client.users.edit', compact('user'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param UsersTableEditRequest $request
     * @param User $user
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function update(UsersTableEditRequest $request, User $user)
    {
        $this->authorize('update', $user);
        $user->update($request->all());
        return redirect()->route('users.show', ['user' => $user])->with('success', __('Successfully updated'));
    }
}

resources/views/client/users/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Edit') }}</div>

                    <div class="card-body">
                        <form method="POST" action="{{ route('users.update', ['user' => $user]) }}">
                            @csrf
                            @method('PUT')
                            <div class="row mb-3">
                                <label for="name" class="col-md-4 col-form-label text-md-right">{{ __('Name') }}</label>

                                <div class="col-md-6">
                                    <input id="name" type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ $user->name }}" required autocomplete="name" autofocus>

                                    @error('name')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>

                            <div class="row mb-3">
                                <label for="email" class="col-md-4 col-form-label text-md-right">{{ __('E-Mail Address') }}</label>

                                <div class="col-md-6">
                                    <input id="email" type="email" class="form-control @error('email') is-invalid @enderror" name="email" value="{{ $user->email  }}" required autocomplete="email">

                                    @error('email')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>

                            <div class="row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        {{ __('Edit') }}
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/client/users/show.blade.php
@extends('layouts.app')

@section('content')
    @can('view', $user)
        <div>
            <h3>{{__('Edit my profile')}} <a class="btn btn-outline-secondary m-lg-3"
                                      href="{{route('users.edit', ['user' => $user])}}">{{__('Edit')}}</a></h3>
        </div>
        <div>
            <h3>{{__('Create New Picture')}} <a class="btn btn-outline-primary m-lg-3"
                                      href="{{route('pictures.create')}}">{{__('Create')}}</a></h3>
        </div>
    @endcan
    <div class="row row-cols-1 row-cols-md-4">
        @foreach($user->pictures as $picture)
            <div class="col mb-4">
                <div class="card">
                    <img style="width: 100%; height: 400px" src="{{asset('/storage/' . $picture->picture)}}"
                         class="card-img-top" alt="...">
                    <div class="card-body">
                        <h5 class="card-title"><a href="{{route('pictures.show', ['picture' => $picture])}}">{{$picture->name}}</a></h5>
                        <p class="card-text">{{$picture->user->name}}</p>
                    </div>
                    @can('delete', $picture)
                        <div class="card-footer">
                            <form method="POST" action="{{route('pictures.destroy', ['picture' => $picture])}}">
                                @csrf
                                @method('DELETE')
                                <button class="btn btn-outline-danger" type="submit">{{ __('Delete') }}</button>
                            </form>
                        </div>
                    @endcan
                </div>
            </div>
        @endforeach
    </div>

@endsection